![](_static/GafferLogo.svg "Gaffer Logo")

# Introduction #

Welcome to the Gaffer user guide, API manual, and reference documentation.

This document provides instructions for how to use Gaffer to complete tasks relevant to both enthusiasts and studios in the VFX domains of look development, lighting, and automated processing and QC. It specifies the Gaffer API and describes some of the application's underlying architecture. It also provide reference information for keyboard shortcuts, node types, and scripting commands.

To learn more about Gaffer, visit our website: [https://gafferhq.org](https://gafferhq.org)

For the purposes of this document, we will assume you have intermediate knowledge of VFX, its terminology, its methods, and its processes. We will also assume you have at least basic familiarity with using Linux and programming paradigms.

Gaffer is open source software hosted and maintained on GitHub: [https://github.com/gafferhq](https://github.com/gafferhq). We strive to keep Gaffer and its documentation bug-free and up-to-date. If you find any bugs with the software, or inaccuracies with this document, we would very much appreciate it if you report it to us on our [Issues page](https://github.com/gafferhq/gaffer/issues).


## Start using gaffer ##

To start, you should:

- [Install Gaffer](GettingStarted/InstallingGaffer/index.md).
- Complete the [Assembling the Gaffer Bot](GettingStarted/TutorialAssemblingTheGafferBot/index.md) tutorial.

If you are are looking to automate VFX processes or develop with Gaffer's API, you should also:

- Complete the [Node Graph Editing in Python tutorial](WorkingWithThePythonScriptingAPI/TutorialNodeGraphEditingInPython/index.md).
- Familiarize yourself with the [Performance Best Practices](WorkingWithTheNodeGraph/PerformanceBestPractices/index.md) for node graphs.


<!-- TOC -->

```eval_rst
.. toctree::
    :hidden:
    :titlesonly:
    :maxdepth: 1
    :caption: User Documentation

    GettingStarted/index.md
    WorkingWithTheNodeGraph/index.md
    WorkingWithScenes/index.md
    WorkingWithImages/index.md
    WorkingWithThePythonScriptingAPI/index.md
    Interface/index.md
```

```eval_rst
.. toctree::
    :hidden:
    :titlesonly:
    :maxdepth: 1
    :caption: Supplemental Material

    Reference/index.md
    ReleaseNotes/index.md
    Appendices/index.md
```

