##########################################################################
#
#  Copyright (c) 2011-2012, John Haddon. All rights reserved.
#  Copyright (c) 2011-2013, Image Engine Design Inc. All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#
#      * Redistributions of source code must retain the above
#        copyright notice, this list of conditions and the following
#        disclaimer.
#
#      * Redistributions in binary form must reproduce the above
#        copyright notice, this list of conditions and the following
#        disclaimer in the documentation and/or other materials provided with
#        the distribution.
#
#      * Neither the name of John Haddon nor the names of
#        any other contributors to this software may be used to endorse or
#        promote products derived from this software without specific prior
#        written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
#  IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
#  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
#  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
#  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
#  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
#  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
##########################################################################

from .TestCase import TestCase
from .WidgetTest import WidgetTest
from .MenuTest import MenuTest
from .SplitContainerTest import SplitContainerTest
from .WindowTest import WindowTest
from .ListContainerTest import ListContainerTest
from .EventSignalCombinerTest import EventSignalCombinerTest
from .FrameTest import FrameTest
from .NameGadgetTest import NameGadgetTest
from .LinearContainerTest import LinearContainerTest
from .NodeGadgetTest import NodeGadgetTest
from .GadgetTest import GadgetTest
from .TabbedContainerTest import TabbedContainerTest
from .GraphEditorTest import GraphEditorTest
from .WidgetSignalTest import WidgetSignalTest
from .EventLoopTest import EventLoopTest
from .TextWidgetTest import TextWidgetTest
from .BoolWidgetTest import BoolWidgetTest
from .ImageTest import ImageTest
from .ButtonTest import ButtonTest
from .CollapsibleTest import CollapsibleTest
from .ImageGadgetTest import ImageGadgetTest
from .StandardNodeGadgetTest import StandardNodeGadgetTest
from .ColorSwatchTest import ColorSwatchTest
from .VariantTest import VariantTest
from .GridContainerTest import GridContainerTest
from .NoduleTest import NoduleTest
from .ProgressBarTest import ProgressBarTest
from .ContainerWidgetTest import ContainerWidgetTest
from .SelectionMenuTest import SelectionMenuTest
from .StandardStyleTest import StandardStyleTest
from .EditorTest import EditorTest
from .PlugValueWidgetTest import PlugValueWidgetTest
from .PathListingWidgetTest import PathListingWidgetTest
from .MultiLineTextWidgetTest import MultiLineTextWidgetTest
from .LabelTest import LabelTest
from .ScrolledContainerTest import ScrolledContainerTest
from .NodeEditorTest import NodeEditorTest
from .ScriptWindowTest import ScriptWindowTest
from .CompoundEditorTest import CompoundEditorTest
from .MultiSelectionMenuTest import MultiSelectionMenuTest
from .StandardGraphLayoutTest import StandardGraphLayoutTest
from .StandardNodeUITest import StandardNodeUITest
from .ViewTest import ViewTest
from .SliderTest import SliderTest
from .NumericPlugValueWidgetTest import NumericPlugValueWidgetTest
from .CompoundNumericPlugValueWidgetTest import CompoundNumericPlugValueWidgetTest
from .NameLabelTest import NameLabelTest
from .NameWidgetTest import NameWidgetTest
from .GLWidgetTest import GLWidgetTest
from .BookmarksTest import BookmarksTest
from .PlaybackTest import PlaybackTest
from .SpacerGadgetTest import SpacerGadgetTest
from .BoxUITest import BoxUITest
from .ConnectionGadgetTest import ConnectionGadgetTest
from .AuxiliaryConnectionsGadgetTest import AuxiliaryConnectionsGadgetTest
from .MessageWidgetTest import MessageWidgetTest
from .ModuleTest import ModuleTest
from .PlugLayoutTest import PlugLayoutTest
from .ViewportGadgetTest import ViewportGadgetTest
from .VectorDataWidgetTest import VectorDataWidgetTest
from .DotNodeGadgetTest import DotNodeGadgetTest
from .DocumentationTest import DocumentationTest
from .LazyMethodTest import LazyMethodTest
from .BackgroundMethodTest import BackgroundMethodTest
from .ReferenceUITest import ReferenceUITest
from .CompoundDataPlugValueWidgetTest import CompoundDataPlugValueWidgetTest
from .GraphGadgetTest import GraphGadgetTest
from .MenuBarTest import MenuBarTest
from .GadgetWidgetTest import GadgetWidgetTest
from .CompoundNoduleTest import CompoundNoduleTest
from .SwitchNodeGadgetTest import SwitchNodeGadgetTest
from .NoduleLayoutTest import NoduleLayoutTest
from .ErrorDialogueTest import ErrorDialogueTest
from .WidgetAlgoTest import WidgetAlgoTest
from .BackupsTest import BackupsTest
from .LayoutsTest import LayoutsTest
from .CompoundNumericNoduleTest import CompoundNumericNoduleTest
from .DocumentationAlgoTest import DocumentationAlgoTest
from .ExamplesTest import ExamplesTest
from .NodeSetEditorTest import NodeSetEditorTest
from .BackdropNodeGadgetTest import BackdropNodeGadgetTest
from .StringPlugValueWidgetTest import StringPlugValueWidgetTest
from .BoolPlugValueWidgetTest import BoolPlugValueWidgetTest
from .NumericWidgetTest import NumericWidgetTest
from .PresetsPlugValueWidgetTest import PresetsPlugValueWidgetTest
from .SpreadsheetUITest import SpreadsheetUITest
from .NodeUITest import NodeUITest
from .AuxiliaryNodeGadgetTest import AuxiliaryNodeGadgetTest
from .CodeWidgetTest import CodeWidgetTest
from .PathColumnTest import PathColumnTest

if __name__ == "__main__":
	unittest.main()
